summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorRobin H. Johnson <robbat2@gentoo.org>2015-08-08 13:49:04 -0700
committerRobin H. Johnson <robbat2@gentoo.org>2015-08-08 17:38:18 -0700
commit56bd759df1d0c750a065b8c845e93d5dfa6b549d (patch)
tree3f91093cdb475e565ae857f1c5a7fd339e2d781e /eclass/common-lisp-common.eclass
downloadgentoo-56bd759df1d0c750a065b8c845e93d5dfa6b549d.tar.gz
gentoo-56bd759df1d0c750a065b8c845e93d5dfa6b549d.tar.bz2
gentoo-56bd759df1d0c750a065b8c845e93d5dfa6b549d.zip
proj/gentoo: Initial commit
This commit represents a new era for Gentoo: Storing the gentoo-x86 tree in Git, as converted from CVS. This commit is the start of the NEW history. Any historical data is intended to be grafted onto this point. Creation process: 1. Take final CVS checkout snapshot 2. Remove ALL ChangeLog* files 3. Transform all Manifests to thin 4. Remove empty Manifests 5. Convert all stale $Header$/$Id$ CVS keywords to non-expanded Git $Id$ 5.1. Do not touch files with -kb/-ko keyword flags. Signed-off-by: Robin H. Johnson <robbat2@gentoo.org> X-Thanks: Alec Warner <antarus@gentoo.org> - did the GSoC 2006 migration tests X-Thanks: Robin H. Johnson <robbat2@gentoo.org> - infra guy, herding this project X-Thanks: Nguyen Thai Ngoc Duy <pclouds@gentoo.org> - Former Gentoo developer, wrote Git features for the migration X-Thanks: Brian Harring <ferringb@gentoo.org> - wrote much python to improve cvs2svn X-Thanks: Rich Freeman <rich0@gentoo.org> - validation scripts X-Thanks: Patrick Lauer <patrick@gentoo.org> - Gentoo dev, running new 2014 work in migration X-Thanks: Michał Górny <mgorny@gentoo.org> - scripts, QA, nagging X-Thanks: All of other Gentoo developers - many ideas and lots of paint on the bikeshed
Diffstat (limited to 'eclass/common-lisp-common.eclass')
-rw-r--r--eclass/common-lisp-common.eclass209
1 files changed, 209 insertions, 0 deletions
diff --git a/eclass/common-lisp-common.eclass b/eclass/common-lisp-common.eclass
new file mode 100644
index 00000000000..7350573238a
--- /dev/null
+++ b/eclass/common-lisp-common.eclass
@@ -0,0 +1,209 @@
+# Copyright 1999-2012 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+#
+# Author Matthew Kennedy <mkennedy@gentoo.org>
+#
+# Sundry code common to many Common Lisp related ebuilds.
+
+# Some handy constants
+
+inherit eutils multilib
+
+CLFASLROOT=/usr/$(get_libdir)/common-lisp/
+CLSOURCEROOT=/usr/share/common-lisp/source/
+CLSYSTEMROOT=/usr/share/common-lisp/systems/
+
+# Many of our Common Lisp ebuilds are either inspired by, or actually
+# use packages and files from the Debian project's archives.
+
+do-debian-credits() {
+ docinto debian
+ for i in copyright README.Debian changelog; do
+ # be silent, since all files are not always present
+ dodoc "${S}"/debian/${i} &>/dev/null || true
+ done
+ docinto .
+}
+
+# Most of the code below is from Debian's Common Lisp Controller
+# package
+
+register-common-lisp-implementation() {
+ PROGNAME=$(basename $0)
+ # first check if there is at least a compiler-name:
+ if [ -z "$1" ] ; then
+ cat <<EOF
+usage: $PROGNAME compiler-name
+
+registers a Common Lisp compiler to the
+Common-Lisp-Controller system.
+EOF
+ exit 1
+ fi
+ IMPL=$1
+ FILE="/usr/$(get_libdir)/common-lisp/bin/$IMPL.sh"
+ if [ ! -f "$FILE" ] ; then
+ cat <<EOF
+$PROGNAME: I cannot find the script $FILE for the implementation $IMPL
+EOF
+ exit 2
+ fi
+ if [ ! -r "$FILE" ] ; then
+ cat <<EOF
+$PROGNAME: I cannot read the script $FILE for the implementation $IMPL
+EOF
+ exit 2
+ fi
+ # install CLC into the lisp
+ sh "$FILE" install-clc || (echo "Installation of CLC failed" >&2 ; exit 3)
+ mkdir /usr/$(get_libdir)/common-lisp/$IMPL &>/dev/null || true
+ chown cl-builder:cl-builder /usr/$(get_libdir)/common-lisp/$IMPL
+
+ # now recompile the stuff
+ for i in /usr/share/common-lisp/systems/*.asd ; do
+ if [ -f $i -a -r $i ] ; then
+ i=${i%.asd}
+ package=${i##*/}
+ clc-autobuild-check $IMPL $package
+ if [ $? = 0 ]; then
+ echo recompiling package $package for implementation $IMPL
+ /usr/bin/clc-send-command --quiet recompile $package $IMPL
+ fi
+ fi
+ done
+ for i in /usr/share/common-lisp/systems/*.system ; do
+ if [ -f $i -a -r $i ] ; then
+ i=${i%.system}
+ package=${i##*/}
+ clc-autobuild-check $IMPL $package
+ if [ $? = 0 ]; then
+ echo recompiling package $package for implementation $IMPL
+ /usr/bin/clc-send-command --quiet recompile $package $IMPL
+ fi
+ fi
+ done
+ echo "$PROGNAME: Compiler $IMPL installed"
+}
+
+unregister-common-lisp-implementation() {
+ PROGNAME=$(basename $0)
+ if [ `id -u` != 0 ] ; then
+ echo $PROGNAME: you need to be root to run this program
+ exit 1
+ fi
+ if [ -z "$1" ] ; then
+ cat <<EOF
+usage: $PROGNAME compiler-name
+
+un-registers a Common Lisp compiler to the
+Common-Lisp-Controller system.
+EOF
+ exit 1
+ fi
+ IMPL=$1
+ IMPL_BIN="/usr/$(get_libdir)/common-lisp/bin/$IMPL.sh"
+ if [ ! -f "$IMPL_BIN" ] ; then
+ cat <<EOF
+$PROGNAME: No implementation of the name $IMPL is registered
+Cannot find the file $IMPL_BIN
+
+Maybe you already removed it?
+EOF
+ exit 0
+ fi
+ if [ ! -r "$IMPL_BIN" ] ; then
+ cat <<EOF
+$PROGNAME: No implementation of the name $IMPL is registered
+Cannot read the file $IMPL_BIN
+
+Maybe you already removed it?
+EOF
+ exit 0
+ fi
+ # Uninstall the CLC
+ sh $IMPL_BIN remove-clc || echo "De-installation of CLC failed" >&2
+ clc-autobuild-impl $IMPL inherit
+ # Just remove the damn subtree
+ (cd / ; rm -rf "/usr/$(get_libdir)/common-lisp/$IMPL/" ; true )
+ echo "$PROGNAME: Common Lisp implementation $IMPL uninstalled"
+}
+
+reregister-all-common-lisp-implementations() {
+ # Rebuilds all common lisp implementations
+ # Written by Kevin Rosenberg <kmr@debian.org>
+ # GPL-2 license
+ local clc_bin_dir=/usr/$(get_libdir)/common-lisp/bin
+ local opt=$(shopt nullglob); shopt -s nullglob
+ cd $clc_bin_dir
+ for impl_bin in *.sh; do
+ impl=$(echo $impl_bin | sed 's/\(.*\).sh/\1/')
+ unregister-common-lisp-implementation $impl
+ register-common-lisp-implementation $impl
+ done
+ cd - >/dev/null
+ [[ $opt = *off ]] && shopt -u nullglob
+}
+
+# BIG FAT HACK: Since the Portage emerge step kills file timestamp
+# information, we need to compensate by ensuring all FASL files are
+# more recent than their source files.
+
+# The following `impl-*-timestamp-hack' functions SHOULD NOT be used
+# outside of this eclass.
+
+impl-save-timestamp-hack() {
+ local impl=$1
+ dodir /usr/share/${impl}
+ tar cpjf "${D}"/usr/share/${impl}/portage-timestamp-compensate -C "${D}"/usr/$(get_libdir)/${impl} .
+}
+
+impl-restore-timestamp-hack() {
+ local impl=$1
+ tar xjpfo /usr/share/${impl}/portage-timestamp-compensate -C /usr/$(get_libdir)/${impl}
+}
+
+impl-remove-timestamp-hack() {
+ local impl=$1
+ rm -rf /usr/$(get_libdir)/${impl} &>/dev/null || true
+}
+
+test-in() {
+ local symbol=$1
+ shift
+ for i in $@; do
+ if [ $i == ${symbol} ]; then
+ return 0 # true
+ fi
+ done
+ false
+}
+
+standard-impl-postinst() {
+ local impl=$1
+ rm -rf /usr/$(get_libdir)/common-lisp/${impl}/* &>/dev/null || true
+ chown cl-builder:cl-builder /usr/$(get_libdir)/common-lisp/${impl}
+ if test-in ${impl} cmucl sbcl; then
+ impl-restore-timestamp-hack ${impl}
+ fi
+ chown -R root:0 /usr/$(get_libdir)/${impl}
+ /usr/bin/clc-autobuild-impl ${impl} yes
+ register-common-lisp-implementation ${impl}
+}
+
+standard-impl-postrm() {
+ local impl=$1 impl_binary=$2
+ # Since we keep our own time stamps we must manually remove them
+ # here.
+ if [ ! -x ${impl_binary} ]; then
+ if test-in ${impl} cmucl sbcl; then
+ impl-remove-timestamp-hack ${impl}
+ fi
+ rm -rf /usr/$(get_libdir)/common-lisp/${impl}/*
+ fi
+}
+
+# Local Variables: ***
+# mode: shell-script ***
+# tab-width: 4 ***
+# End: ***